Subject: Re: [PATCH 3/3] decrement static keys on real destroy time

From: Glauber Costa <[email-masked]>
Date: Fri, 20 Apr 2012 16:39:00 -0300

On 04/20/2012 04:38 AM, KAMEZAWA Hiroyuki wrote:
>>   			mem_cgroup_get(memcg);
>> >  -			sk->sk_cgrp = sk->sk_prot->proto_cgroup(memcg);
>> >  +			sk->sk_cgrp = cg_proto;
>> >    		}
> 
> 
> Is this correct ? cg_proto->active can be true before all jump_labels are
> patched, then we can loose accounting. That will cause underflow of
> res_countner.
> 
> cg_proto->active should be set after jump_label modification.
> Then, things will work, I guess.
> 
> Thanks,
> -Kame
> 

Kame,

You are right.

The first update needs to be done after the jump label activation as
well. I got myself confused with the two flags =(

I will repost with this fixed once I get into agreement with Tejun and
Li about the lockless ->destroy()